%{
#include <stdio.h>
#include "nodes.h"
int yydebug = 1;
%}

%token 	INTEGER_LITERAL
%left '-' '+'
%left '*' '/'
%{
/*
 * Global state used by the parser.
 */
Node *ParseTree={NULL};
/*
 * Reset the global state ready for the next file to be parsed.
 */
static void ResetState(void)
{
}

%}


%{
extern int yylex();

static void yyerror (s)
char *s;
{
  printf("%s:%ld %s\n",yycurrfilename(),yycurrlinenum(),s);
}

%}

%union 
{
	Node_Expression *node;
	int value;
};
%start CompilationUnit
%type <node> Expression
%type <value> INTEGER_LITERAL

%%

CompilationUnit
	: Expression
	{
		ParseTree=(Node*) Node_Result_create($1);
		ResetState();
	}

Expression
	: Expression '+' Expression 
		{
			$$ = (Node_Expression*)Node_Add_create($1,$3);
		} 
	| Expression '-' Expression 
		{
			$$ =(Node_Expression*)Node_Sub_create($1,$3);
		}
	| Expression '/' Expression 
		{
			$$ = (Node_Expression*)Node_Div_create($1,$3);
		}
	| Expression '*' Expression 
		{
			$$ = (Node_Expression*)Node_Mul_create($1,$3);
		}
	| INTEGER_LITERAL 
		{
			$$ = (Node_Expression*)Node_Constant_create($1);
		}
	| '(' Expression ')' 
		{
			$$=$2;
		}
	;
%%
